
from pywinauto.application import Application
from src import data


def send_text(text: str) -> None:
    app = Application()
    app.connect(title='Path of Exile')
    win = app.window_(title_re='Path of Exile')
    text = escape_mods(text)
    win.TypeKeys('{ENTER}^A{DELETE}' + text + '{ENTER}', with_spaces=True)


def escape_mods(text: str) -> str:
    text = text.replace('%', '{%}')
    text = text.replace('+', '{+}')
    text = text.replace('^', '{^}')
    return text


def send_to(user: str, text: str) -> None:
    send_text(f'@{user} {text}')


def send_to_format(type: str, message: data.Message, conf: dict()) -> None:
    """[summary]

    Args:
        type (str): [description]
        message (data.Message): [description]
        conf (dict): [description]
    """
    text = conf['Chat'][type].format(message=message.message,
                                     date=message.date,
                                     channel=message.channel.name,
                                     user=message.user,
                                     guild=message.guild,
                                     to_from=message.to_from,
                                     item=message.trade.item,
                                     amount=message.trade.amount,
                                     currency=message.trade.currency,
                                     tab=message.trade.tab,
                                     row=message.trade.row,
                                     col=message.trade.col,
                                     league=message.trade.league)
    send_to(message.user, text)


def invite(message: data.Message) -> None:
    send_text(f'/invite {message.user}')


def trade(message: data.Message) -> None:
    send_text(f'/tradewith {message.user}')
